=== debian/changelog ===
gophernicus (3.0.1-1) unstable; urgency=medium

  * Initial release (Closes: #828988)

 -- Ryan Kavanagh <rak@debian.org>  Sun, 17 May 2020 15:27:11 -0400
