=== debian/control ===
Source: gophernicus
Section: net
Priority: optional
Maintainer: Ryan Kavanagh <rak@debian.org>
Build-Depends: debhelper-compat (= 13),
               dh-exec,
               libwrap0-dev,
Standards-Version: 4.5.0
Homepage: http://gophernicus.org/
Vcs-Browser: https://salsa.debian.org/debian/gophernicus
Vcs-Git: https://salsa.debian.org/debian/gophernicus.git

Package: gophernicus
Architecture: any
Depends: ${misc:Depends},
         ${shlibs:Depends},
Description: modern, full-featured gopher daemon
 gophernicus is a modern, full-featured gopher daemon written with security in
 mind. Its features include:
  * automatic gophermap generation for directories
  * personal gopherspaces
  * virtual hosting
  * most parts of cge CGI/1.1 standard
  * selector rewriting
  * session tracking, throttling, and statistics
  * tls/ssl and proxy support
