=== debian/rules ===
#!/usr/bin/make -f

export DEB_BUILD_MAINT_OPTIONS = hardening=+all

%:
	dh $@

override_dh_installsystemd:
	dh_installsystemd gophernicus.socket
	dh_installsystemd gophernicus@.service
