## gophernicus 3.1.1

=== debian/changelog ===
gophernicus (3.1.1-3) unstable; urgency=low

  * Explain the use of /srv/gopher instead of /var/gopher in README.Debian
  * Updated IRC channel location at upstream's request, 09_readme_irc.diff

 -- Ryan Kavanagh <rak@debian.org>  Fri, 28 May 2021 12:45:59 -0400

gophernicus (3.1.1-2) unstable; urgency=medium

  * Update changelog for 3.1.1-1 to mention that it fixes a build error
  * Remove the proper user/group on purge

 -- Ryan Kavanagh <rak@debian.org>  Sat, 23 Jan 2021 14:00:55 -0500

gophernicus (3.1.1-1) unstable; urgency=medium

  * New upstream release
    + Drop unneeded patches and refresh others
    + Update copyright holders
    + Upstream ships its own manpages. No longer ship/install our own.
    + Fixes build error (Closes: #966853)
  * Bump standards-version to 4.5.1
  * Update homepage to use https
  * Update rules to use build system
  * Set Rules-Requires-Root: no
  * Do not hardcode buildd's hostname, 02_do_not_hardcode_hostname.diff
  * Do not include build directory paths in installed files,
    03_do_not_hardcode_build_path.diff
  * Use buildflags set by dpkg-buildflags, 07_buildflags.diff
  * Create user _gophernicus instead of using running as nobody,
    08_no_systemd_nobody.diff

 -- Ryan Kavanagh <rak@debian.org>  Sat, 02 Jan 2021 22:40:24 -0500
