=== debian/rules ===
#!/usr/bin/make -f

export DEB_BUILD_MAINT_OPTIONS = hardening=+all

%:
	dh $@

override_dh_auto_configure:
	./configure \
		--gopherroot=/srv/gopher \
		--listener=systemd,xinetd \
		--prefix=/usr

override_dh_auto_install:
	dh_auto_install
	# Don't install directories under /srv. See README.Debian.
	rm -fr debian/gophernicus/srv
	rm -fr debian/gophernicus/etc/sysconfig

override_dh_auto_clean:
	dh_auto_clean
	rm -f Makefile
