=== debian/watch ===
version=4
opts="filenamemangle=s%(?:.*?)?v?(\d[\d.]*)\.tar\.gz%gophernicus-$1.tar.gz%" \
   https://github.com/gophernicus/gophernicus/tags \
   (?:.*?/)?v?(\d[\d.]*)\.tar\.gz debian uupdate
